# Notes

This is a bug fix and fetaure release of MahApps.Metro.

# Features

- It's now possible to get an opened dialog from a MetroWindow #1739
- Allow the user to disable the window dragging #1669
- Dialogs can now use the `ColorScheme = MetroDialogColorScheme.Inverted`
- Add `MouseOverGlowEnabled` to `FlipView`
- Back/Forward Buttons now enabled/disabled instead visible/or not
- `AreAnimationsEnabled` property for `Flyout` to show the `Flyout` directly or with animation
- `MaximumBodyHeight` for `MetroDialogSettings`, so we can get a `ScrollViewer` for tall dialog content
- `IsMinButtonEnabled`, `IsMaxRestoreButtonEnabled` and `IsCloseButtonEnabled` to enable/disable the window buttons at `WindowButtonCommands` @romerod #1562
- `IdealForegroundDisabledBrush` to set the foreground for disabled window buttons at `WindowButtonCommands` #1581
- `MetroWindow` animates now on minimize/maximize/restore window action (limited by ignoring the taskbar) #1756
- It's now possible to put the MahApps styles only in a window and the main app will remain unaffected (all buttons and commands will be styled as good as well.) #1777
- The underline position is based on `TabstripPlacement` property of `TabControl`. (`ControlsHelper.IsUnderlined`) #1737 #1478
- It's now possible to upgrade the `WindowPlacementSettings` on version change (minor breaking change) #1787 #1736
- New property `ShowSeparators` for WindowCommands, so it's possible to hide the `WindowCommands` seperators
- `MetroTabItem` now supports the `TabControlHelper.IsUnderlined` attached property #1795 #1796
- Flyout focus enhancement #1805  
It's now possible to set `FocusedElement` and `AllowFocusElement` to enable focusing mechanism
  + If `AllowFocusElement` is set to `True` the `Flyout` tries to focus the first focusable element, if there is no focusable element, it tries to focus an element in the header section.
  + If `FocusedElement` is set the `Flyout` focus this element.
- Better default CapsLock icon for `PasswordBox` [SHA](https://github.com/MahApps/MahApps.Metro/commit/709abc49abb575017a8bb660bc129656172824b5)
- Add a callback for `ShowIconOnTitleBar` #1810, so we can hide the icon e.g. after window is loaded #1688
- New `CornerRadiuis` property for `MetroButton` and `ToggleButton` style [SHA](https://github.com/MahApps/MahApps.Metro/commit/efdc5f8e57a3b85d81969bd04dc7ff27e199e9ea), [SHA](https://github.com/MahApps/MahApps.Metro/commit/d4ff9da467533eeee6959fe2ed3cf4755ce852ec), [SHA](https://github.com/MahApps/MahApps.Metro/commit/cd31273b5005d950b0725684ecf193f3e19c6319)

# Changes
- Simplify styles (backwards-compatible changes and fixes, e.g. disabled style) for `PasswordBox`, `TextBox`, `DatePicker`, `CheckBox`, `RadioButton`, `SquareButton`, `MetroButton`, `ToggleButton`, `ComboBox`, `ComboBoxItem`
- Use `IdealForegroundColor` for `AccentSelectedColorBrush` (for better results in `ListBox`, `ListView`, `DataGrid` and `ComboBox`)

# Bugfixes

- Fixed maximize button path only displays partially when using SaveWindowPosition #1580 #1693
- Fixed background of ComboBox #1713
- Use `UseLayoutRounding` for `MetroWindow` for better pixel stuff [SHA](https://github.com/MahApps/MahApps.Metro/commit/b3c19573ba52847aa42fe1c0ff3ef064e8d9ba17)
- Fixed ideal foreground for some color styles #1748
![](https://camo.githubusercontent.com/9df3efb07f02b8d95a471a493762433fa8eb442c/687474703a2f2f6673312e64697265637475706c6f61642e6e65742f696d616765732f3135303131312f79766a356e3333352e706e67)
- Fixed disabled window buttons foreground (and add `IdealForegroundDisabledBrush` to handle this) #1581
- Fixed wrong max/restore button tool tip when maximized [SHA](https://github.com/MahApps/MahApps.Metro/commit/4a1a8f91c6588c034a6e5ef3fac64e4eacce6845)
- Fixed wrong window size while moving maximized window between monitors #1275 
- Fixed the cursor of the button in the `ProgressDialog` #1763 
- Fixed text wrapping for MessageDialog Message #1776 #1766 
- Fixed missing behavior when toggle `UseNoneWindowStyle` [SHA](https://github.com/MahApps/MahApps.Metro/commit/c1d36f5eb4b22cea92383c256f4c1102141696ce)
- Fixed foreground color of WindowComands and WindowButtonCommands #1788 #1503
- Fixed PasswordBox with `ClearTextButton` doesnt show the button #1718
- Fixed wrong text for buttons in dialogs (it's now preserve by default) #1793 #1755
- Fixed usage of ClearTextButton: Subscribe to clear button even if control is already loaded. #1764 #1797
- Fixed SplitButton SelectedIndex and SelectedItem (binds now two way by default) #1798
- Fixed losing Window shadow [EnableDWMDropShadow] #1791 #1799
- Fixed alignment of decrement button on vertical scrollbars #1800
- Fixed non working button click action with `TextboxHelper.ClearTextButton="True"` after visibilty change #1268 #1809
- Fixed CaretBrush after theme changed for `PasswordBox` [SHA](https://github.com/MahApps/MahApps.Metro/commit/a5808a1c1e0272e38f57f69c1d5cb5a1ee9dfca8) and `DatePicker` [SHA](https://github.com/MahApps/MahApps.Metro/commit/74ff36001e92a722b65f532c4c651e48d653b4a9) 
- Fixed disabled `ComboBox` style (looks now like other controls) [SHA](https://github.com/MahApps/MahApps.Metro/commit/97fa00f0f7588f6f6b63ec33bd9144d431d827d1)
- Fixed disabled `DatePicker` style and wrong showing watermark [SHA](https://github.com/MahApps/MahApps.Metro/commit/96c23f54385d31e4492cb149446242cfdafe02da)
- Fixed wrong WindowPlacement saving with Border snaps #1811 #1814
- Fixed color disappearing for DataGrid selection #1728 #1816
- Fixed FocusVisualStyle in Flyouts (surround Flyout content with AdornerDecorator) [SHA](https://github.com/MahApps/MahApps.Metro/commit/dc58b92f815484de8866d4af608fad22b699047d)

